{$M$1000,0,$A0000,L-,D-,S-,I-,E-}
Program PCXViewer;

Uses VESA,Crt,Dos;

Type PByte = ^Byte;

Var dt,ln    : PByte;
    filename : Array[0..79] Of Char;
    fl       : File;

    header : Record
      Manufacturer : Byte;     { Always $0A, or 10 }
      Version      : Byte;     { Version number: 0 - Mono; 2 - 16 Colour; 3 - Def Pal. 5 - 256 Colour }
      Encoding     : Byte;     { Always 1 }
      BitsPerPixel : Byte;     { Colour bits }
      XMin, YMin   : Integer;  { Image Origin }
      XMax, YMax   : Integer;  { Image Dimensions }
      HRes, VRes   : Integer;  { Resolution Values }
      Palette      : Array [0..47] Of Byte; { Colour Palette }
      Reserved     : Byte;
      ColourPlanes : Byte;     { Colour Planes }
      BytesPerLine : Integer;  { Line Buffer Size }
      PaletteType  : Integer;  { Grey or Colour Palette }
      Filler       : Array [0..57] Of Byte;
    End;

    palette        : Array[0..767] Of Byte;

Function StrPCopy(Dest:PChar; Source:String):PChar; Assembler;
Asm
	Push    ds
	Cld
	Lds     si,Source
	Les     di,Dest
	Mov     bx,di
	Mov     dx,es
	Lodsb
	Xor     ah,ah
	Xchg    ax,cx
	Rep     Movsb
	Xor     al,al
	Stosb
	Xchg    ax,bx
	Pop     ds
End;

Procedure BlankPalette;
Var r : Registers;
    p : Array[0..767] Of Byte;
Begin
  FillChar(p,768,0);
  r.ax:=$1012;
  r.bx:=0;
  r.cx:=256;
  r.dx:=Ofs(p);
  r.es:=Seg(p);
  Intr($10,r);
End;

Procedure SetPalette;
Const Pal16:Array[0..15]Of Byte=(0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
Var   i : Word;
      r : Registers;
Begin
  If header.BitsPerPixel=8 Then For i:=0 To 767 Do palette[i]:=palette[i] Shr 2
  Else For i:=0 To 15 Do Begin
    palette[Pal16[i]*3]:=header.Palette[i*3] Shr 2;
    palette[Pal16[i]*3+1]:=header.Palette[i*3+1] Shr 2;
    palette[Pal16[i]*3+2]:=header.Palette[i*3+2] Shr 2;
  End;
  r.ax:=$1012;
  r.bx:=0;
  r.cx:=256;
  r.dx:=Ofs(palette);
  r.es:=Seg(palette);
  Intr($10,r);
End;

Procedure Image256(dat,line:PByte); Assembler;
Var  xmax,bytes : Word;
     i,ym,bank  : Word;
     handle     : Word;
     dseg,btg   : Word;
     cp         : Word;
Asm
	Mov    dseg,ds
	Mov    bank,0
	Mov    ax,header.YMax
	Inc    ax
	Cmp    ax,VesaMode.Height
	Jnz    @0A
	Mov    ax,VesaMode.Height
  @0A:  Mov    ym,ax
	Mov    ax,header.Xmax
	Inc    ax
	Mov    xmax,ax
	Mov    ax,VesaMode.bytes
	Mov    bytes,ax
	Sub    ax,xmax
	Mov    btg,ax

	Mov    es,VesaMode.SegA
	Xor    di,di
	Mov    dx,Offset filename
	Mov    ax,$3D00
	Int    $21
	Jc     @Ex
	Mov    handle,ax

	Lds    si,dat
	Mov    dx,si                  { Read a byte }
	Mov    cx,$80
	Mov    bx,handle
	Mov    ah,$3F
	Int    $21

	Mov    i,0                    { Initialize loop variables }
	Call   @@FR
	Jmp    @01

  @@FR: Lds    si,dat                 { DS:SI -> disk buffer }
	Mov    dx,si                  { Read a byte }
	Mov    cx,$FFF0
	Mov    bx,handle
	Mov    ah,$3F
	Int    $21
	Mov    bx,ax                  { Number of bytes to decode }
	RetN

  @01:  Xor    dx,dx
	Xor    ch,ch

  @02:  Lodsb                         { AL - data byte }
	Dec    bx
	Jnz    @03

	Push   ax
	Push   cx
	Push   dx
	Call   @@FR
	Pop    dx
	Pop    cx
	Pop    ax

  @03:  Mov    ah,al                  { see if it is a string or data }
	And    ah,$C0
	Cmp    ah,$C0
	Jne    @05

	And    al,$3F                 { Set repeat counter }
	Mov    cl,al
	Lodsb                         { AL - data to repeat }
	Dec    bx
	Jnz    @04

	Push   ax
	Push   cx
	Push   dx
	Call   @@FR
	Pop    dx
	Pop    cx
	Pop    ax

  @04:  Add    dx,cx
	Push   dx
	Mov    dx,di
	Add    dx,cx
	Pop    dx
	Jc     @0B
	Rep    Stosb
	Jmp    @06
  @0B:  Stosb                           { Loop to fill area with data }
	Or     di,di
	Jnz    @0C
	Inc    bank
	Call   @B1
  @0C:  Loop   @0B
	Jmp    @06

  @05:  Stosb
	Inc    dx
	Or     di,di
	Jnz    @06
	Inc    bank
	Call   @B1

  @06:  Cmp    dx,xmax
	Jne    @02
	{ End of draw line }

	Add    di,btg
	Jnc    @07
	Inc    bank
	Call   @B1
  @07:  Inc    i
	Mov    ax,ym
	Cmp    ax,i
	Jne    @01

	Jmp    @Ex

  @B1:  Push    ax
	Push    ds
	Mov     ds,dseg
	Mov     al,vesaon
	Or      al,al
	Jz      @B3
	Push    bx
	Push    dx
	Mov     dx,bank
	Xor     bx,bx
	Mov     ax,64
	Mul     dx
	Div     VesaMode.Gran
	Mov     dx,ax
	Push    dx
	Call    VesaMode.WinFunc
	Pop     dx
	Inc     bx
	Call    VesaMode.WinFunc
	Pop     dx
	Pop     bx
  @B3:  Pop     ds
	Pop     ax
	RetN

  @Ex:  Mov    bx,handle              { Close the file }
	Mov    ah,$3E
	Int    $21

	Mov    ds,dseg
End;

{ Doesn't work properly in 1280x1024 for one line (a two bank line) }
Procedure Image16(dat,line:PByte); Assembler;
Var  bytes,vbytes,bank : Word;
     i,ym ,dseg   : Word;
     handle,vseg  : Word;
     cp,mask      : Byte;
Asm
	Mov    dseg,ds

        Mov    cx,header.XMax
        Mov    ah,$FF
        Not    cl
        And    cl,7
        Shl    ah,cl
        Mov    mask,ah

        Mov    bank,0
        Mov    ax,VesaMode.SegA
        Mov    vseg,ax
        Mov    ax,VesaMode.Bytes
        Mov    vbytes,ax
	Mov    ax,header.BytesPerLine
	Mov    bytes,ax
	Mov    al,header.ColourPlanes
	Mov    cp,al
	Mov    ax,header.YMax
	Inc    ax
	Mov    ym,ax

	Mov    dx,Offset filename
	Mov    ax,$3D00
	Int    $21
	Jc     @Ex
	Mov    handle,ax

	Lds    si,dat
	Mov    dx,si                  { Read a byte }
	Mov    cx,$80
	Mov    bx,handle
	Mov    ah,$3F
	Int    $21

	Mov    i,0                    { Initialize loop variables }
	Call   @@FR
	Jmp    @01

  @@FR: Lds    si,dat                 { DS:SI -> disk buffer }
	Mov    dx,si                  { Read a byte }
	Mov    cx,$FFF0
	Mov    bx,handle
	Mov    ah,$3F
	Int    $21
	Mov    bx,ax                   { Number of bytes to decode }
	RetN

  @01:  Les    di,line                { ES:DI -> decoded line }
	Xor    dx,dx
	Xor    ch,ch

  @02:  Lodsb                         { AL - data byte }
	Dec    bx
	Jnz    @03

	Push   ax
	Push   cx
	Push   dx
	Call   @@FR
	Pop    dx
	Pop    cx
	Pop    ax

  @03:  Mov    ah,al                  { see if it is a string or data }
	And    ah,$C0
	Cmp    ah,$C0
	Jne    @05

	And    al,$3F                 { Set repeat counter }
	Mov    cl,al
	Lodsb                         { AL - data to repeat }
	Dec    bx
	Jnz    @04

	Push   ax
	Push   cx
	Push   dx
	Call   @@FR
	Pop    dx
	Pop    cx
	Pop    ax

  @04:  Add    dx,cx
	Rep    Stosb                  { Loop to fill area with data }
	Jmp    @06

  @05:  Stosb
	Inc    dx

  @06:  Mov    ax,bytes
	Shl    ax,2                 { x4 for all planes }
	Cmp    ax,dx
	Jne    @02
	Mov    es,vseg
	Push   ds
	Push   si

	{ Draw line }

  @10:  Lds    si,line                { DS:SI -> image line }
	Mov    ax,vbytes
	Mul    i
	Mov    di,ax
        Cmp    dx,bank
        Je     @09
        Mov    bank,dx
        Call   @B1

  @09:  Mov    ah,1                   { Set colour plane to draw on }

  @11:  Push   di
	Mov    al,2
	Mov    dx,$3C4
	Out    dx,ax

	Mov    cx,bytes
        Dec    cx
        Dec    cx
	Mov    al,es:[di]             { Perform read to initialize video buffer }
	Rep    Movsb                  { Transfer data line to video buffer }
        Lodsb
        And    al,mask
        Stosb
        Movsb

	{ End of draw line }

	Pop    di
	Shl    ah,1
	Cmp    ah,16
	Jne    @11

	Inc    i
	Pop    si
	Pop    ds
	Mov    ax,ym
	Cmp    ax,i
	Jne    @01

	Jmp    @Ex

  @B1:  Push    ax
	Push    ds
	Mov     ds,dseg
	Mov     al,vesaon
	Or      al,al
	Jz      @B3
	Push    bx
	Push    dx
	Mov     dx,bank
	Xor     bx,bx
	Mov     ax,64
	Mul     dx
	Div     VesaMode.Gran
	Mov     dx,ax
	Push    dx
	Call    VesaMode.WinFunc
	Pop     dx
	Inc     bx
	Call    VesaMode.WinFunc
	Pop     dx
	Pop     bx
  @B3:  Pop     ds
        Pop     ax
        RetN

  @Ex:  Mov    bx,handle              { Close the file }
	Mov    ah,$3E
	Int    $21

	Mov    ds,dseg
End;

Procedure ShowImage;
Begin
  GetMem(dt,$FFF0);
  GetMem(ln,2048);
  Case header.BitsPerPixel Of
    1: Begin
	 Case header.XMax Of
	      0..639  : SetMode($12);
	    640..799  : SetMode($102);
	    800..1023 : SetMode($104);
	   1024..9999 : SetMode($106);
	 End;
         SetPalette;
         {BlankPalette;}
	 Image16(dt,ln);
       End;
    8: Begin
	 Case header.XMax Of
	      0..319  : SetMode($13);
	    320..639  : SetMode($101);
	    640..799  : SetMode($103);
	    800..1023 : SetMode($105);
	   1024..9999 : SetMode($107);
	 End;
         SetPalette;
         {BlankPalette;}
	 Image256(dt,ln);
       End;
  End;
  {SetPalette;}
  Sound(660);
  Delay(100);
  Sound(880);
  Delay(50);
  Sound(440);
  Delay(75);
  NoSound;
  ReadKey;
  SetMode(3);
  FreeMem(ln,2048);
  FreeMem(dt,$FFF0);
End;

Begin
  If ParamCount>0 Then Begin
    If Pos('.',ParamStr(1))=0 Then StrPCopy(filename,ParamStr(1)+'.PCX')
      Else StrPCopy(filename,ParamStr(1));
    Assign(fl,filename);
    {$I-}
    Reset(fl,1);
    {$I+}
    If IOResult=0 Then Begin
      BlockRead(fl,header,128);
      If header.BitsPerPixel=8 Then Begin
	Seek(fl,FileSize(fl)-769);
	BlockRead(fl,palette,1);
	If (palette[0]=12)And(IOResult=0) Then Begin
	  {$I-}
	  BlockRead(fl,palette,768);
	  {$I+}
        End;
      End;
      Close(fl);
      If header.Manufacturer={PC + Roman X}10{ = PCX!!} Then Begin
        Writeln;
        Writeln('Version  . . . . ',header.Version);
        Writeln('Width  . . . . . ',header.XMax+1,' pixels');
        Writeln('Height . . . . . ',header.YMax+1,' pixels');
        Writeln('Bits per Pixel . ',header.BitsPerPixel);
        Writeln('Planes . . . . . ',header.ColourPlanes);
        Writeln('X Resolution . . ',header.HRes,' DPI');
        Writeln('Y Resolution . . ',header.VRes,' DPI');
        Write  ('Palette Type . . ');
        If header.PaletteType=2 Then Writeln('Grey scale') Else
          Writeln('Colour');
        Writeln;
        If ((header.XMax<640)And(header.YMax<480)And(header.BitsPerPixel<>1))
           Or((header.YMax<320)And(header.YMax<200))Or(IsVesa) Then
        If header.BitsPerPixel*header.ColourPlanes>1 Then Begin
          Writeln('Press a key to show the image');
          ReadKey;
          ShowImage;
        End Else Writeln('Cannot display the image without VESA graphics support');
      End Else Writeln('It is not a PCX file');
    End Else Writeln('Cannot find the file');
  End Else Writeln('Usage: PCXVIEW <filename>');
End.

