
Unit FLC;
(*
  Q&D Unit, die Routinen etc zum FLI/FLC-Format bereitstellt
*)
Interface


Type TFLIHeader = Record
        FileSize : LongInt;
        FormatID : Word; { AF12h for FLC, AF11h for FLI }
        NumFrames : Word;
        Width : Word;
        Height : Word;
        Depth : Word;
        Flags : Word; { = 0003h }
        Speed : LongInt;
        Reserved : Word;
        Created : LongInt;
        CreatorNum : LongInt;
        LastModified : LongInt;
        LastModifier : LongInt;
        AspectX : Word;
        AspectY : Word;
        Reserved2 : Array[0..37] of Byte;
        offsetFrame1 : LongInt;
        offsetFrame2 : LongInt;
        Reserved3 : Array[0..39] of Byte;
      End;

Type TFLCBlock = Record
       Size : LongInt;
       BlockID : Word;
       SubBlocks : Word;
       Reserved : Array[0..7] of Byte;
     End;

     TFLCSubBlock = Record
       Size : LongInt;
       BlockID : Word;
       Data : Record End;
     End;

     PFLCColorPacket = ^TFLCColorPacket;
     TFLCColorPacket = Record
       SkipCount : Byte; (* Number of colors to skip *)
       ColorTriplets : Byte; (* Number of RGB colors to set *)
       Data : Record End;
     End;

     PFLCColorTriplet = ^TFLCColorTriplet;
     TFLCColorTriplet = Record
       R,G,B : Byte;
     End;

Function GetFLCBlockName( ID : Word ) : String;
(* Konvertiert einen SubBlockTyp in etwas lesbares *)

Implementation

function makestr(w : word) : String;
var c:string;
begin
  Str(w,c);
  makestr := c;
end;

function GetFLCBlockName(ID : word) : string;
begin
  case Id of
    4 : GetFLCBlockName := 'Palette-256';
    7 : GetFLCBlockName := 'Word delta frame';
   11 : GetFLCBlockName := 'Palette-64';
   12 : GetFLCBlockName := 'Byte delta frame';
   13 : GetFLCBlockName := 'Black frame';
   15 : GetFLCBlockName := 'Byte RLE';
   16 : GetFLCBlockName := 'Uncompressed frame';
   18 : GetFLCBlockName := 'Stamp';
   else GetFLCBlockName := 'Unknown ('+makestr(id)+')';
  end;
end;

End.

