{ Super VGA256 v.2.0 }
{ Demjanishin Vladislav
  E-Mail:nitromanit@mail.ru
  http://amonit.boom.ru}

{$G+,N+}
Unit svga256;

interface

Uses XMS2;

function isVGA:boolean;
procedure WaitRetrace;
procedure GetVESAInfo;
procedure GetVESAModeInfo(mode:word);
procedure InitGraphScreen;
procedure ExitGraphScreen;
procedure Get_palette(var buf);
procedure Set_palette(var buf);
procedure Mode(num:word);
procedure ClrScreen;
procedure Pset(x,y:word;c:byte);
procedure AsmPset;
function Areset(x,y:word):byte;
procedure AsmAreset;
procedure Pcls(x1,y1,x2,y2:word;color:byte);
procedure Line(x1,y1,x2,y2:integer;color:byte);
procedure Box(x1,y1,x2,y2:integer;color:byte);
procedure Bar(x1,y1,x2,y2:integer;acolor,bcolor:byte);
procedure Circle(xc,yc,r:integer;color:byte);
procedure Arc(xc,yc,rx,ry:integer;color:byte);
procedure Paint(x,y:integer;acolor,bcolor:byte);
procedure Get_Window(xl,yl,xr,yr:word;var buf);
procedure Put_Window(x,y:word;var buf);
procedure Get_BigWindow(xl,yl,xr,yr:word;var buf:TXMMpointer);
procedure Put_BigWindow(xl,yl:word;var buf:TXMMpointer);

type
         TWinBufp=record
                 Width,Height:word;
                 image:array [0..64160] of byte;
                 end;
            TRGB=record
                 red,green,blue:byte;
                 end;
         TPalette=array [0..255] of TRGB;
        VESA_Mode=record
                  mode:word;
	          x,y:word;
	          pages:word;
                  end;

     TVESAInfo=record
            ID:array [0..3] of char; {dd 0x41534556 = "VESA" VBE Signature}
           Ver:word;                {dw VBE Version}
  OemStringPtr:pointer;         {dd Pointer to OEM String}
      Capatibs:longint;        {db 4 dup (?) Capabilities of graphics cont}
      ModeList:pointer;         {dd Pointer to Video Mode List}
   TotalMemory:word;            {dw Number of 64kb memory blocks}
     {--- Added for VBE 2.0 ---}
      Reserved:array [0..221] of byte; {db 222 dup (?) Reserved for VBE implementation
                                                    scratch area}
       OemData:array [0..255] of byte; {db 256 dup (?) Data Area for OEM Strings}
              end; {512 bytes}

 TVESAModeInfo=record
   {--- Mandatory information for all VBE revisions ---}
      ModeAttr:word; {dw mode attributes}
     WinAAttrs,     {db window A attributes}
     WinBAttrs:byte;{db window B attributes}
     WinGranul,     {dw window granularity}
       WinSize,       {dw window size}
       WinASeg,       {dw window A start segment}
       WinBSeg:word;  {dw window B start segment}
    WinFuncPtr:pointer; {dd pointer to window function}
 BytesPerScanLine,      {dw bytes per scan line}
   {--- Mandatory information for VBE 1.2 and above ---}
         Width,         {dw horizontal resolution in pixels or chars}
        Height:word;    {dw vertical resolution in pixels or chars}
     CharWidth,         {db character cell width in pixels}
    CharHeight,         {db character cell height in pixels}
        Planes,         {db number of memory planes}
  BitsPerPixel,         {db bits per pixel}
         Banks,         {db number of banks}
   MemoryModel,         {db memory model type}
      BankSize,         {db bank size in KB}
    ImagePages:byte;    {db number of images}
      Reserved:array [0..226] of char;
              end; {256 bytes}

const    sbufsize=2000;
         VESAText          = 0;
         VESA640x400x256   = 1;
         VESA640x480x256   = 2;
         VESA800x600x256   = 3;
         VESA1024x768x256  = 4;
         VESA1280x1024x256 = 5;
         segA000 = $0A000;
         {------}
         black=0;
         white=15;
         blue=1;
         gray=7;
         offcos=540;
         mulsin=6;
         {---Colors---}
         clBlack=0;
         clBlue=1;
         clNavy=clBlue;        {Win}
         clGreen=2;
         clCyan=3;
         clTeal=clCyan;        {Win}
         clRed=4;
         clMagenta=5;
         clPurple=clMagenta;   {Win}
         clBrown=6;
         clLightGray=7;
         clSilver=clLightGray; {Win}
         clDarkGray=8;
         clGray=clDarkGray;
         clLightBlue=9;
         clAqua=clLightBlue;   {Win}
         clLightGreen=10;
         clLime=clLightGreen;  {Win}
         clLightCyan=11;
         clLightRed=12;
         clLightMagenta=13;
         clRose=clLightMagenta;
         clFuchsia=clRose; {Win}
         clYellow=14;
         clWhite=15;
  Metrix:Array[0..5] of VESA_Mode=
             ((mode:$003;x:001;y:001;pages:0),
              (mode:$100;x:640;y:400;pages:3),
              (mode:$101;x:640;y:480;pages:4),
              (mode:$103;x:800;y:600;pages:7),
              (mode:$105;x:1024;y:768;pages:12),
              (mode:$107;x:1280;y:1024;pages:20));

var lastpage:word;
    MinX,MaxX,MinY,MaxY,MaxColor:word;
    tabsin:array [0..2700] of single; 
    strbuf:array [0..sbufsize] of byte; { CashBuf for XMS mov }
    Screen:VESA_Mode;
    GranulMul,GranulAdd:word;
    VESAInfo:TVESAInfo;
    ModeInfo:TVESAModeInfo;

implementation

var j:integer;

procedure GetVESAInfo;assembler;
asm
    mov ax,4f00h
    lea di,VESAInfo
    int 10h
end;

procedure GetVESAModeInfo(mode:word);assembler;
asm
    mov ax,4f01h
    mov cx,mode
    lea di,ModeInfo
    int 10h
end;

procedure mode(num:word);
const MulGranules:array [1..18] of word=(0,1,0,2,0,0,0,3,0,0,0,0,0,0,0,4,
                                         5,6);
begin
GetVESAModeInfo(Metrix[num].mode);
{Granul:=0;ModeInfo.WinGranul;}
GranulMul:=MulGranules[64 div ModeInfo.WinGranul];
GranulAdd:=64 div ModeInfo.WinGranul;
 move(Metrix[num],Screen,Sizeof(VESA_Mode));
 MaxX:=screen.x-1;
 MaxY:=screen.y-1;
 MinX:=0;
 MinY:=0;
 MaxColor:=256;
 asm
  mov lastpage,$FFFF
  mov bx,screen.mode
  mov ax,$4F02
  int $10
 end;
end;

procedure initgraphscreen;
begin
mode(VESA640x400x256);
end;

procedure exitgraphscreen;
begin
mode(VESAText);
end;

procedure Get_palette(var buf);assembler;
asm
    push es
    mov ax,1017h
    mov bx,0
    mov cx,256
    les dx,buf
    int 10h
    pop es
end;

procedure Set_palette(var buf);assembler;
asm
    push es
    mov ax,1012h
    mov bx,0
    mov cx,256
    les dx,buf
    int 10h
    pop es
end;

procedure page(num:word);assembler;
asm
    push ax
    push bx
    push dx
    mov dx,num
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
    pop dx
    pop bx
    pop ax
end;

procedure pset(x,y:word;c:byte);assembler;
asm
    push es
    push cx
    mov ax,x
    cmp ax,MaxX
    ja  @pn
    cmp ax,MinX
    jb  @pn
    mov ax,y
    cmp ax,MaxY
    ja  @pn
    cmp ax,MinY
    jb  @pn
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mov bx,y
    mul bx
    add ax,x
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:mov al,c
    mov es:[di],al
@pn:pop cx
    pop es
end;

procedure asmPset;assembler;{di-x,ax-y,bl-color  맮  asm-楤}
asm
    push cx
    push ax
    push dx
    push di
    push es
    cmp di,MaxX
    ja  @pn
    cmp di,MinX
    jb  @pn
    cmp ax,MaxY
    ja  @pn
    cmp ax,MinY
    jb  @pn
    push bx
    mov bx,ax
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mul bx
    add ax,di
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:pop bx
    mov al,bl
    mov es:[di],al
@pn:pop es
    pop di
    pop dx
    pop ax
    pop cx
end;

procedure ClrScreen;assembler; {working - 60*clrscreen=19 1/18 sec}
asm
    push ax
    push bx
    push es
    push di
    push dx
    push cx
    mov si,screen.pages
    inc si
    mov cx,GranulMul
    shl si,cl {4}
    mov ax,0a000h
    mov es,ax
    xor dx,dx
@a1:mov ax,4f05h
    xor bx,bx
    mov lastpage,dx
    int 10h
    xor ax,ax
    mov cx,32768
    xor di,di
    cld
rep stosw
    add dx,GranulAdd {10h}
    cmp dx,si {40h}
    jne @a1
@nd:pop cx
    pop dx
    pop di
    pop es
    pop bx
    pop ax
end;

procedure ClrScreen1; {working - 10*clrscreen=20 1/18 sec}
var x,y:word;
begin
for y:=0 to screen.y do
    for x:=0 to screen.x do
    pset(x,y,10);   {working - 10*clrscreen=28 1/18 sec}
    {asm
        mov di,x
        mov ax,y
        mov bl,10
        call asmpset
    end;}
end;

function Areset(x,y:word):byte;assembler;
asm
    push cx
    push es
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mov bx,y
    mul bx
    add ax,x
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    pusha
    push dx
    call page
    popa
 @a:mov al,es:[di]
    pop es
    pop cx
end;

procedure asmAreset;assembler;{di-x,ax-y,bl-color  맮  asm-楤}
asm
    push cx
    push ax
    push dx
    push di
    push es
    {push bx}
    mov bx,ax
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mul bx
    add ax,di
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:{pop bx}
    {mov al,bl}
    mov bl,es:[di]
    pop es
    pop di
    pop dx
    pop ax
    pop cx
end;

procedure pcls1(x1,y1,x2,y2:word;color:byte);assembler;
var intX,intY:word;
asm
           push es
           push di
           mov ax,x2
           cmp ax,x1
           ja  @a1
           mov bx,x1
           mov x1,ax
           mov ax,bx
       @a1:sub ax,x1
           inc ax
           mov intX,ax
           mov ax,y2
           cmp ax,y1
           ja  @a2
           mov bx,y1
           mov y1,ax
           mov ax,bx
       @a2:sub ax,y1
           inc ax
           mov intY,ax
           mov cx,intY
           mov bl,color
       @a3:push cx
           mov cx,intX
           mov di,x1
           mov ax,y1
       @a4:call asmpset
           inc di
           loop @a4
           pop cx
           inc y1
           loop @a3
           pop di
           pop es
end;

procedure pcls(x1,y1,x2,y2:word;color:byte);assembler;
var intX,intY:word;
asm
    push es
    push di
    mov ax,x2
    cmp ax,x1
    ja  @a1
    mov bx,x1
    mov x1,ax
    mov ax,bx
@a1:sub ax,x1
    inc ax
    mov intX,ax
    mov ax,y2
    cmp ax,y1
    ja  @a2
    mov bx,y1
    mov y1,ax
    mov ax,bx
@a2:sub ax,y1
    inc ax
    mov intY,ax
    mov ax,0a000h
    mov es,ax
    mov cx,intY
    mov bl,color
@a3:push cx
    mov cx,intX
    mov di,x1
    mov ax,y1
@a4:{call asmpset}
    push cx
    push ax
    push di
    mov bx,ax
    mov ax,screen.x
    mul bx
    add ax,di
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:mov al,color
    mov es:[di],al
    pop di
    pop ax
    pop cx
    inc di
    loop @a4
    pop cx
    inc y1
    loop @a3
    pop di
    pop es
end;

procedure Line(x1,y1,x2,y2:integer;color:byte);assembler;
VAR X,Y,INTX,INTY,ADDX,INTX2,INTY2:integer;
asm
     @lal2:MOV    AX,Y1
           CMP    AX,Y2
           JNG    @L013F
           MOV    BX,Y2
           MOV    Y2,AX
           MOV    Y1,BX
           MOV    AX,X1
           MOV    BX,X2
           MOV    X2,AX
           MOV    X1,BX
    @L013F:MOV    AX,X2
           SUB    AX,X1
           MOV    INTX,AX
           MOV    AX,Y2
           SUB    AX,Y1
           MOV    INTY,AX
           MOV    ADDX,1
           CMP    INTX,0
           JG     @L015A
           SUB    ADDX,2
           NEG    INTX
    @L015A:MOV    AX,INTX
           CMP    AX,INTY
           JNG    @L0188
           MOV    CX,INTX
           MOV    AX,INTY
           ADD    AX,AX
           MOV    INTY2,AX
           MOV    BX,AX
           SUB    BX,INTX
           MOV    AX,INTX
           ADD    AX,AX
           MOV    INTX2,AX
           MOV    AX,X1
           MOV    X,AX
           MOV    AX,Y1
           MOV    Y,AX
           cmp ax,MaxY
           ja @lend1
           cmp ax,MinY
           jb @lend1
           mov ax,X
           cmp ax,MaxX
           ja @lend1
           cmp ax,MinX
           jb @lend1
           push bx
           mov di,X
           mov ax,Y
           mov bl,color
           call asmpset
           pop bx
    @lend1:CMP    CX,0
           JZ     @L0184
    @L0170:CMP    BX,0
           JL     @L017B
           INC    Y
           SUB    BX,INTX2
    @L017B:ADD    BX,INTY2
           MOV    AX,X
           ADD    AX,ADDX
           MOV    X,AX
           cmp ax,MaxX
           ja @lend2
           cmp ax,MinX
           jb @lend2
           mov ax,y
           cmp ax,MaxY
           ja @lend2
           cmp ax,MinY
           jb @lend2
           push bx
           mov di,X
           mov ax,Y
           mov bl,color
           call asmpset
           pop bx
    @lend2:dec cx
           jnz @L0170
    @L0184:JMP    @L01AE
    @L0188:MOV    CX,INTY
           MOV    AX,INTX
           ADD    AX,AX
           MOV    INTX2,AX
           MOV    BX,AX
           SUB    BX,INTY
           MOV    AX,INTY
           ADD    AX,AX
           MOV    INTY2,AX
           MOV    AX,X1
           MOV    X,AX
           MOV    AX,Y1
           MOV    Y,AX
           cmp ax,MaxY
           ja @lend3
           cmp ax,MinY
           jb @lend3
           mov ax,X
           cmp ax,MaxX
           ja @lend3
           cmp ax,MinX
           jb @lend3
           push bx
           mov di,X
           mov ax,Y
           mov bl,color
           call asmpset
           pop bx
    @lend3:CMP    CX,0
           JZ     @L01AE
    @L019A:CMP    BX,0
           JL     @L01A3
           MOV    AX,X
           ADD    AX,ADDX
           MOV    X,AX
           SUB    BX,INTY2
    @L01A3:ADD    BX,INTX2
           INC    Y
           mov ax,Y
           cmp ax,MaxY
           ja @lend4
           cmp ax,MinY
           jb @lend4
           mov ax,X
           cmp ax,MaxX
           ja @lend4
           cmp ax,MinX
           jb @lend4
           push bx
           mov di,X
           mov ax,Y
           mov bl,color
           call asmpset
           pop bx
    @lend4:dec cx
           jnz @L019A
    @L01AE:
end;

procedure box(x1,y1,x2,y2:integer;color:byte);
begin
line(x1,y1,x2,y1,color); {up line}
line(x1,y1,x1,y2,color); {left line}
line(x2,y1,x2,y2,color); {right line}
line(x1,y2,x2,y2,color); {down line}
end;

procedure bar(x1,y1,x2,y2:integer;acolor,bcolor:byte);{acolor - 梥 ࠭}
begin                                  {bcolor - 梥 ⥫}
box(x1,y1,x2,y2,acolor);
if (x1>x2) and (y1>y2) then begin pcls(x2+1,y2+1,x1-1,y1-1,bcolor);exit;end;
if (y1>y2) then begin pcls(x1+1,y2+1,x2-1,y1-1,bcolor);exit;end;
if (x1>x2) then begin pcls(x2+1,y1+1,x1-1,y2-1,bcolor);exit;end;
if (x2-x1=0) or (y2-y1=0) then exit;
pcls(x1+1,y1+1,x2-1,y2-1,bcolor);
end;

procedure Get_Window(xl,yl,xr,yr:word;var buf);assembler;
var interval_x,interval_y:word;
asm
           push es
           push si
           les di,buf
           mov ax,xr
           sub ax,xl
           inc ax
           cld
           stosw
           mov interval_x,ax
           mov ax,yr
           sub ax,yl
           inc ax
           stosw
           mov interval_y,ax
       @g1:mov cx,interval_x
           mov si,xl
           mov bx,yl
       @g2:{push dx}
           push cx
           push di
           push es
           push bx
           mov ax,0a000h
           mov es,ax
           mov ax,screen.x
           mul bx
           add ax,si
           adc dx,0
           mov cx,GranulMul
           shl dx,cl {4}
           mov di,ax
           cmp dx,lastpage
           je @a
           mov lastpage,dx
           mov ax,4f05h
           xor bx,bx
           int 10h
        @a:mov al,es:[di]
           pop bx
           pop es
           pop di
           pop cx
           {pop dx}
           cld
           stosb
           inc si
           loop @g2
           cmp interval_y,1
           je @gn
           dec interval_y
           inc yl
           jmp @g1
       @gn:pop si
           pop es
end;

procedure Put_Window(x,y:word;var buf);assembler;
var interval_x,interval_y,dds:word;
asm
           push es
           push si
           les di,buf
           mov ax,es:[di]
           add di,2
           mov interval_x,ax
           mov ax,es:[di]
           add di,2
           mov interval_y,ax
       @p1:mov cx,interval_x
           mov si,x
       @g2:mov al,es:[di]
           inc di
           mov bl,al
           mov ax,y
           {push dx}
           push cx
           push di
           push es
           push bx
           mov bx,ax
           mov ax,0a000h
           mov es,ax
           mov ax,screen.x
           mul bx
           add ax,si
           adc dx,0
           mov cx,GranulMul
           shl dx,cl {4}
           mov di,ax
           cmp dx,lastpage
           je @a
           mov lastpage,dx
           mov ax,4f05h
           xor bx,bx
           int 10h
        @a:pop bx
           mov al,bl
           mov es:[di],al
           pop es
           pop di
           pop cx
           {pop dx}
           inc si
           loop @g2
           cmp interval_y,1
           je  @pn
           dec interval_y
           inc y
           jmp @p1
       @pn:pop si
           pop es
end;

procedure Get_BigWindow4(xl,yl,xr,yr:word;var buf:TXMMpointer); {working}
{640x400 - 0.330 sec}
{640x480 - 0.380 sec}
{800x600 - 0.330 sec}
var interval_x,interval_y,x,y,count:word;
    offs,o:longint;
    b,c:byte;

 procedure PutByte(b:byte);
 begin
 strbuf[count]:=b;
 if count=499 then begin
    moveMemtoXMS(buf,@strbuf,o,500);
    o:=o+500;count:=0;exit;
    end;
 inc(count);
 end;

 procedure GetBigStr(y:word);
 var x:word;
 begin
 for x:=0 to interval_x-1 do begin
     b:=Areset(xl+x,yl+y);
     PutByte(b);
     end;
 end;

begin
interval_x:=xr-xl+1;
interval_y:=yr-yl+1;
PutMemW(buf,0,interval_x);
PutMemW(buf,2,interval_y);
offs:=8;o:=offs;count:=0;
for y:=0 to interval_y-1 do
    GetBigStr(y);
if count>0 then moveMemtoXMS(buf,@strbuf,o,(count div 2) shl 1);
end;

procedure Put_BigWindow4(xl,yl:word;var buf:TXMMpointer);{working}
var interval_x,interval_y,x,y,count:word;
    offs,o:longint;
    b:byte;

 function GetByte:byte;
 begin
 GetByte:=strbuf[count];
 if count=499 then begin
    moveXMStoMem(buf,@strbuf,o,500);
    o:=o+500;count:=0;exit;
    end;
 inc(count);
 end;

 procedure PutBigStr(y:word);
 var x:word;
 begin
 for x:=0 to interval_x-1 do begin {when x=387,or x=502}
     b:=GetByte;
     pset(xl+x,yl+y,b);
     end;
 end;

begin
interval_x:=GetMemW(buf,0);
interval_y:=GetMemW(buf,2);{2}
offs:=8;o:=offs;count:=0;
moveXMStoMem(buf,@strbuf,o,500);o:=o+500;
for y:=0 to interval_y-1 do
    PutBigStr(y);
end;

procedure Get_BigWindow5(xl,yl,xr,yr:word;var buf:TXMMpointer); {working}
{size of cashbuf for XMS mov must be more 1000 bytes}
{tested on k6-200}
{640x400 - 0.275 sec x 1 call and 0.2418 x 10 call}
{640x480 - 0.330 sec x 1 call and 0.2912 x 10 call}
{800x600 - 0.440 sec x 1 call and 0.4341 x 10 call}
var interval_x,interval_y,x,y,count:word;
    offs,o:longint;
    b,c:byte;

begin
interval_x:=xr-xl+1;
interval_y:=yr-yl+1;
PutMemW(buf,0,interval_x);
PutMemW(buf,2,interval_y);
offs:=8;o:=offs;count:=0;
for y:=0 to interval_y-1 do
    for x:=0 to interval_x-1 do begin
        b:=Areset(xl+x,yl+y);
        strbuf[count]:=b;
        inc(count);
        if count=sbufsize then begin
           moveMemtoXMS(buf,@strbuf,o,sbufsize);
           o:=o+sbufsize;count:=0;
           end;
        end;
if count>0 then moveMemtoXMS(buf,@strbuf,o,(count div 2) shl 1);
end;

procedure Put_BigWindow5(xl,yl:word;var buf:TXMMpointer); {working}
{size of cashbuf for XMS mov must be more 1000 bytes}
{tested on k6-200}
{640x400 - 0.110 sec x 1 call and 0.1319 x 10 call}
{640x480 - 0.165 sec x 1 call and 0.1593 x 10 call}
{800x600 - 0.275 sec x 1 call and 0.2473 x 10 call}
var interval_x,interval_y,x,y,count:word;
    offs,o:longint;
    b:byte;

begin
interval_x:=GetMemW(buf,0);
interval_y:=GetMemW(buf,2);{2}
offs:=8;o:=offs;count:=0;
moveXMStoMem(buf,@strbuf,o,sbufsize);o:=o+sbufsize;
for y:=0 to interval_y-1 do
    for x:=0 to interval_x-1 do begin
        b:=strbuf[count];
        inc(count);
        if count=sbufsize then begin
           moveXMStoMem(buf,@strbuf,o,sbufsize);
           o:=o+sbufsize;count:=0;
           end;
        pset(xl+x,yl+y,b);
        end;
end;

procedure Get_BigWindow(xl,yl,xr,yr:word;var buf:TXMMpointer);
{size of cashbuf for XMS mov must be more 1000 bytes}
{tested on k6-200}
{640x400 - N/A sec for 1 call and 0.1813 for 10 call}
{640x480 - N/A sec for 1 call and 0.2143 for 10 call}
{800x600 - N/A sec for 1 call and 0.3516 for 10 call}
var interval_x,interval_y,x,y,count,px,py:word;
    offs,o:longint;
    b,c:byte;

begin
interval_x:=xr-xl+1;
interval_y:=yr-yl+1;
PutMemW(buf,0,interval_x);
PutMemW(buf,2,interval_y);
offs:=8;o:=offs;count:=0;
for y:=0 to interval_y-1 do
    for x:=0 to interval_x-1 do begin
        px:=xl+x;py:=yl+y;
   asm
    push cx
    push es
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mov bx,py
    mul bx
    add ax,px
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:mov al,es:[di]
    mov b,al
    pop es
    pop cx
  end;
        strbuf[count]:=b;
        inc(count);
        if count=sbufsize then begin
           moveMemtoXMS(buf,@strbuf,o,sbufsize);
           o:=o+sbufsize;count:=0;
           end;
        end;
if count>0 then moveMemtoXMS(buf,@strbuf,o,(count div 2) shl 1);
end;

procedure Put_BigWindow(xl,yl:word;var buf:TXMMpointer);
{size of cashbuf for XMS mov must be more 1000 bytes}
{tested on k6-200}
{640x400 - N/A sec x 1 call and 0.0769 x 10 call}
{640x480 - N/A sec x 1 call and 0.0879 x 10 call}
{800x600 - N/A sec x 1 call and 0.1484 x 10 call}
var interval_x,interval_y,x,y,count,px,py:word;
    offs,o:longint;
    b:byte;
begin
interval_x:=GetMemW(buf,0);
interval_y:=GetMemW(buf,2);{2}
if (interval_x=0) or (interval_y=0) then exit;
offs:=8;o:=offs;count:=0;
moveXMStoMem(buf,@strbuf,o,sbufsize);o:=o+sbufsize;
for y:=0 to interval_y-1 do
    for x:=0 to interval_x-1 do begin
        b:=strbuf[count];
        inc(count);
        if count=sbufsize then begin
           moveXMStoMem(buf,@strbuf,o,sbufsize);
           o:=o+sbufsize;count:=0;
           end;
        px:=xl+x;py:=yl+y;
   asm
    push cx
    push es
    mov ax,px
    cmp ax,MaxX
    ja  @pn
    cmp ax,MinX
    jb  @pn
    mov ax,py
    cmp ax,MaxY
    ja  @pn
    cmp ax,MinY
    jb  @pn
    mov ax,0a000h
    mov es,ax
    mov ax,screen.x
    mov bx,py
    mul bx
    add ax,px
    adc dx,0
    mov cx,GranulMul
    shl dx,cl {4}
    mov di,ax
    cmp dx,lastpage
    je @a
    mov lastpage,dx
    mov ax,4f05h
    xor bx,bx
    int 10h
 @a:mov al,b
    mov es:[di],al
@pn:pop es
    pop cx
  end;
      end;
end;

procedure Circle(xc,yc,r:integer;color:byte);
var x,y,count,point:integer;
    a,step:single;
begin
a:=0;step:=45/r;
count:=2*r+1;
repeat
point:=trunc(mulsin*a);
x:=trunc(r*tabsin[point]);
y:=trunc(r*tabsin[offcos+point]);
pset(xc+x,yc+y,color);
pset(xc-x,yc+y,color);
pset(xc+x,yc-y,color);
pset(xc-x,yc-y,color);
a:=a+step;
dec(count);
until count=0;
end;

procedure Arc(xc,yc,rx,ry:integer;color:byte);
var x,y,count,point:integer;
    a,step:single;
begin
if rx>ry then begin
   a:=0;step:=45/rx;
   count:=2*rx+1;
   repeat
   point:=trunc(mulsin*a);
   x:=trunc(rx*tabsin[point]);
   y:=trunc(ry*tabsin[offcos+point]);
   pset(xc+x,yc+y,color);
   pset(xc-x,yc+y,color);
   pset(xc+x,yc-y,color);
   pset(xc-x,yc-y,color);
   a:=a+step;
   dec(count);
   until count=0;
   end
else begin
   a:=0;step:=45/ry;
   count:=2*ry+1;
   repeat
   point:=trunc(mulsin*a);
   x:=trunc(rx*tabsin[point]);
   y:=trunc(ry*tabsin[offcos+point]);
   pset(xc+x,yc+y,color);
   pset(xc-x,yc+y,color);
   pset(xc+x,yc-y,color);
   pset(xc-x,yc-y,color);
   a:=a+step;
   dec(count);
   until count=0;
   end;
end;

procedure paint(x,y:integer;acolor,bcolor:byte); {acolor - 梥 ࠭}
                                             {bcolor - 梥 ⥫}
type
     pw=^word;
     aword=array [1..160] of word;
     revrec=record
            xa,ya:word;
     end;
     bword=array [1..100] of revrec;

var
     fline1,fline2:aword;
     preadyzon,pfoundzon,phelperzon:pw;
     preadyline,pfoundline,phelperline:^aword;
     rline1,rline2:bword;
     rlineready,rlinefound,rlinehelp:^bword;
     rzonready,rzonfound,rzonhelp:pw;
     deltaY:integer;
     c,d,e,f:word;

     procedure Filline(x,y:word);

     procedure Zoneline(x:integer;y:word);
     var i,j:boolean;
         b,bclr,cclr:byte;
         yd:word;
     begin {Zoneline}
       {if areset(x,y)=acolor then exit;}
       bclr:=bcolor;
       b:=areset(x-1,y);
       while (b<>acolor) and (x-1>=MinX+1) do begin
             dec(x);
       b:=areset(x-1,y);
       end;
       i:=true;j:=true;
       repeat
         pset(x,y,bcolor);
         yd:=y+deltaY;
         b:=areset(x,yd);
         if (b<>acolor) and ((yd>=MinY) and (yd<=MaxY)) then begin
            if i=true then begin
               pfoundzon^:=pfoundzon^+1;
               pfoundline^[pfoundzon^]:=x;
               i:=false;
            end;
         end
         else i:=true;
         b:=areset(x,y-deltaY);
         {yd:=y-deltaY;}
         if ((b<>acolor) and (b<>bcolor)) and ((yd>=MinY) and (yd<=MaxY)) then
         begin
           if j=true then begin
              rzonfound^:=rzonfound^+1;
              rlinefound^[rzonfound^].xa:=x;
              rlinefound^[rzonfound^].ya:=y-deltaY;
              j:=false;
           end;
         end
         else j:=true;
         inc(x);
         b:=areset(x,y);
       until (b=acolor) or (b=bcolor) or (x>=MaxX+1);
       i:=true;j:=true;
     end;  {Zoneline}
     begin {Filline}
       pfoundzon^:=0;preadyzon^:=0;
       Zoneline(x,y);y:=y+deltaY;
       repeat
         phelperline:=pfoundline;pfoundline:=preadyline;
         preadyline:=phelperline;
         phelperzon:=pfoundzon;pfoundzon:=preadyzon;
         preadyzon:=phelperzon;
         while preadyzon^<>0 do begin
         Zoneline(preadyline^[preadyzon^],y);
         preadyzon^:=preadyzon^-1;
         end;
         y:=y+deltaY;
       until pfoundzon^=0;
       y:=y-deltaY;
     end;  {Filline}

begin {paint}
  if areset(x,y)=acolor then exit;
  preadyzon:=@c;pfoundzon:=@d;
  rzonready:=@e;rzonfound:=@f;
  rlineready:=@rline1;rlinefound:=@rline2;
  preadyline:=@fline1;pfoundline:=@fline2;
  rzonready^:=0;rzonfound^:=0;
  deltaY:=-1;
  Filline(x,y);
  repeat
    rzonhelp:=rzonfound;rzonfound:=rzonready;
    rzonready:=rzonhelp;
    rlinehelp:=rlinefound;rlinefound:=rlineready;
    rlineready:=rlinehelp;
    deltaY:=-deltaY;
    while rzonready^<>0 do begin
    Filline(rlineready^[rzonready^].xa,rlineready^[rzonready^].ya);
    rzonready^:=rzonready^-1;
    end;
  until rzonfound^=0;
end;  {paint}

{--------------------------------}

Function isVGA:boolean; assembler;
asm
@CheckForVga:mov AH,1ah
             mov AL,00h
             int 10h
             cmp AL,1ah
             jne @NoVGA
             cmp BL,07h
             je  @VgaPresent
             cmp BL,08h
             je  @VgaPresent
      @NoVGA:xor ax,ax
             jmp @done
 @VgaPresent:mov ax,0ffffh
       @done:
end;

Procedure WaitRetrace; Assembler;
  { This waits until you are in a Verticle Retrace ... this means that all
    screen manipulation you do only appears on screen in the next verticle
    retrace ... this removes most of the "fuzz" that you see on the screen
    when changing the pallette. It unfortunately slows down your program
    by "synching" your program with your monitor card ... it does mean
    that the program will run at almost the same speed on different
    speeds of computers which have similar monitors. In our SilkyDemo,
    we used a WaitRetrace, and it therefore runs at the same (fairly
    fast) speed when Turbo is on or off. }

Label
  L1, L2;
Asm
    Mov DX, 3DAH
L1:
    In AL,DX
    And AL,08H
    JNZ L1
L2:
    In AL,DX
    And AL,08H
    JZ  L2
End;

begin
MinX:=0;
MinY:=0;
MaxColor:=256;
if XMS_init(1)<>0 then begin writeln('no XMS driver');halt;end;
{if not isVGA then begin writeln('For run this program need VGA card.');halt(1);end;}
{ mode(VESA640x480x256);} {40sec pcls 256 colors/ vga256 8sec pcls 256 colors}
{ mode(VESA640x400x256);} {33sec pcls 256 colors}
{ mode(VESA800x600x256);} {1.20 minutes pcls 256 colors}
for j:=0 to 2700 do tabsin[j]:=sin(0.1666666*pi*j/180);
end.